

#ifndef BUILD_HELPHER_H_INCLUDED
#define BUILD_HELPHER_H_INCLUDED 1

#include "difbasic.h"

#define FLAG_NO_COMPUTE_MD5      0x0010
#define FLAG_NO_COMPUTE_SHA1     0x0020
#define FLAG_NO_COMPUTE_SHA256   0x0040


#define BUILDERR_ERR_SOURCE_FILE_ERROR     (-2)
#define BUILDERR_ERR_DEST_FILE_ERROR       (-3)
#define BUILDERR_ERR_RECOMPRESS            (-4)
#ifdef __cplusplus
extern "C" {
#endif

int SVFAPI BuildPatchFromTwoFile(const char*DfsToBuild,const char*FirstFilename,const char*SecondFileName);
int SVFAPI BuildPatchFromTwoFileEx(const char*DfsToBuild, const char*FirstFilename, const char*SecondFileName, char*errText, dfuLong32 dwErrTextSize);
int SVFAPI BuildPatchFromTwoFileEx2(const char*DfsToBuild, const char*FirstFilename, const char*SecondFileName, char*errText, dfuLong32 dwErrTextSize,
	signed long CompressRatio,signed long HashBits,signed long BlockSize);
int SVFAPI BuildPatchFromTwoFileEx3(const char*DfsToBuild, const char*FirstFilename, const char*SecondFileName, char*errText, dfuLong32 dwErrTextSize,
	signed long CompressRatio, signed long HashBits, signed long BlockSize, signed long supp_flags);
	
#if defined (COMPRESSIONPARAM_DEFINED)
int SVFAPI BuildPatchFromTwoFileExCprParam(const char*DfsToBuild, const char*FirstFilename, const char*SecondFileName, char*errText, dfuLong32 dwErrTextSize,
    COMPRESSIONPARAM* pCprParamToBuildFnc, signed long supp_flags);
#endif
int SVFAPI RecompressPatch(const char* DfsOrg,const char*DfsToBuild, char*errText, dfuLong32 dwErrTextSize,
	signed long CompressRatio, signed long HashBits, signed long BlockSize, signed long supp_flags);
#ifdef __cplusplus
}
#endif


#endif
