// SmartVersion DLL c# header
// translation of winimage.h header, made with the help of Tom McCartney

using System.Runtime.InteropServices;
using System.Text;
using System;
using System.IO;


public static class MinizipWrapper
{
    public const Int32 APPEND_STATUS_CREATE        = (0);
    public const Int32 APPEND_STATUS_CREATEAFTER = (1);
    public const Int32 APPEND_STATUS_ADDINZIP = (2);


    [DllImport("svfdll.dll", EntryPoint = "zipOpen", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern IntPtr zipOpen(String szSvfFileName, Int32 append);

    [DllImport("svfdll.dll", EntryPoint = "zipOpenNewFileInZip", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 zipOpenNewFileInZip(IntPtr zipfile, String fileName, IntPtr zipfi, IntPtr extrafield_local, Int32 size_extrafield_local,
                                IntPtr extrafield_global, Int32 size_extrafield_global, String comment, Int32 method, int level);

    [DllImport("svfdll.dll", EntryPoint = "zipWriteInFileInZip", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 zipWriteInFileInZip(IntPtr zipfile, String Buffer, Int32 len);

    [DllImport("svfdll.dll", EntryPoint = "zipWriteInFileInZip", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 zipWriteInFileInZip(IntPtr zipfile, byte[] Buffer, Int32 len);

    [DllImport("svfdll.dll", EntryPoint = "zipCloseFileInZip", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 zipCloseFileInZip(IntPtr zipfile);
    
    [DllImport("svfdll.dll", EntryPoint = "zipClose", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 zipClose(IntPtr zipfile, String globalComment);


    [DllImport("svfdll.dll", EntryPoint = "unzOpen", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern IntPtr unzOpen(String szSvfFileName);

    [DllImport("svfdll.dll", EntryPoint = "unzOpen64", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern IntPtr unzOpen64(String szSvfFileName);

    [DllImport("svfdll.dll", EntryPoint = "unzClose", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzClose(IntPtr zipfile);

    [DllImport("svfdll.dll", EntryPoint = "unzGoToFirstFile", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzGoToFirstFile(IntPtr zipfile);

    [DllImport("svfdll.dll", EntryPoint = "unzGoToNextFile", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzGoToNextFile(IntPtr zipfile);

    [DllImport("svfdll.dll", EntryPoint = "unzLocateFile", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzLocateFile(IntPtr zipfile, String fileName, Int32 caseSensitive);

    [DllImport("svfdll.dll", EntryPoint = "unzOpenCurrentFile", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzOpenCurrentFile(IntPtr zipfile);

    [DllImport("svfdll.dll", EntryPoint = "unzReadCurrentFile", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzReadCurrentFile(IntPtr zipfile, byte[] Buffer, Int32 len);

    [DllImport("svfdll.dll", EntryPoint = "unzCloseCurrentFile", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzCloseCurrentFile(IntPtr zipfile);

    /*
    extern int ZEXPORT unzGetCurrentFileInfo64 OF((unzFile file,
                         unz_file_info64 *pfile_info,
                         char *szFileName,
                         uLong fileNameBufferSize,
                         void *extraField,
                         uLong extraFieldBufferSize,
                         char *szComment,
                         uLong commentBufferSize));
    */

    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
    public struct unz_global_info
    {
        public UInt32 number_entry;
        public UInt32 size_comment;
    } ;

    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
    public struct unz_global_info64
    {
        public UInt64 number_entry;
        public UInt32 size_comment;
    } ;

    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
    public struct tm_unz_s
    {
        public UInt32 tm_sec;
        public UInt32 tm_min;
        public UInt32 tm_hour;
        public UInt32 tm_mday;
        public UInt32 tm_mon;
        public UInt32 tm_year;
    } ;

    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
    public struct unz_file_info_s
    {
        public UInt32 version;
        public UInt32 version_needed;
        public UInt32 flag;
        public UInt32 compression_method;
        public UInt32 dosDate;
        public UInt32 crc;
        public UInt32 compressed_size;
        public UInt32 uncompressed_size;
        public UInt32 size_filename;
        public UInt32 size_file_extra;
        public UInt32 size_file_comment;

        public UInt32 disk_num_start;
        public UInt32 internal_fa;
        public UInt32 external_fa;

        public tm_unz_s tmu_date;
    } ;

    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
    public struct unz_file_info64_s
    {
        public UInt32 version;
        public UInt32 version_needed;
        public UInt32 flag;
        public UInt32 compression_method;
        public UInt32 dosDate;
        public UInt32 crc;
        public UInt64 compressed_size;
        public UInt64 uncompressed_size;
        public UInt32 size_filename;
        public UInt32 size_file_extra;
        public UInt32 size_file_comment;

        public UInt32 disk_num_start;
        public UInt32 internal_fa;
        public UInt32 external_fa;

        public tm_unz_s tmu_date;
    } ;


    [DllImport("svfdll.dll", EntryPoint = "unzGetGlobalInfo", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzGetGlobalInfo(IntPtr zipfile, ref unz_global_info globalInfo);

    [DllImport("svfdll.dll", EntryPoint = "unzGetGlobalInfo64", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzGetGlobalInfo64(IntPtr zipfile, ref unz_global_info64 globalInfo64);

    [DllImport("svfdll.dll", EntryPoint = "unzGetCurrentFileInfo", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzGetCurrentFileInfo(IntPtr zipfile, ref unz_file_info_s fileInfo,
                                                     StringBuilder fileName, Int32 fileNameSize,
                                                     byte[] extraField, Int32 extraFieldSize,
                                                     StringBuilder comment, Int32 commentSize);

    [DllImport("svfdll.dll", EntryPoint = "unzGetCurrentFileInfo64", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern Int32 unzGetCurrentFileInfo64(IntPtr zipfile, ref unz_file_info64_s fileInfo64,
                                                     StringBuilder fileName, Int32 fileNameSize,
                                                     byte[] extraField, Int32 extraFieldSize,
                                                     StringBuilder comment, Int32 commentSize);



    public static Int32 unzGetCurrentFileInfoString(IntPtr zipfile, ref unz_file_info_s fileInfo,
                                                     out String fileNameString,
                                                     byte[] extraField, Int32 extraFieldSize,
                                                     out String commentString)
    {
        Int32 filenameSize = 0x400;
        Int32 commentSize = 0x10000;

        StringBuilder sbComment = new StringBuilder(commentSize + 1);
        StringBuilder sbFileName = new StringBuilder(filenameSize + 1);
        Int32 ret = unzGetCurrentFileInfo(zipfile, ref fileInfo, sbFileName, sbFileName.Capacity-1, extraField, extraFieldSize, sbComment, sbComment.Capacity-1);
        fileNameString = sbFileName.ToString();
        commentString = sbComment.ToString();
        return ret;                                   
    }
 



    public static Boolean WriteFileInZip(IntPtr zipf,String FileNameToRead, String FileNameInZip)
    {
        const Int32 BufSizeZip = 16384;

        FileStream fs = new FileStream(FileNameToRead, FileMode.Open, FileAccess.Read);
        byte[] buff = new byte[BufSizeZip];
        MinizipWrapper.zipOpenNewFileInZip(zipf, FileNameInZip, (IntPtr)0, (IntPtr)0, 0, (IntPtr)0, 0, "", 8, -1);
        for (; ; )
        {
            Int32 readthis = fs.Read(buff, 0, BufSizeZip); //Read bytes 
            if (readthis == 0)
                break;

            MinizipWrapper.zipWriteInFileInZip(zipf, buff, readthis);
        }
        fs.Close();
        fs.Dispose();
        MinizipWrapper.zipCloseFileInZip(zipf);
         
        return true;
    }


    public static Boolean WriteStringInFileInZip(IntPtr zipf, String textToWrite, String FileNameInZip)
    {

        byte[] buff = System.Text.Encoding.ASCII.GetBytes(textToWrite);
         
        MinizipWrapper.zipOpenNewFileInZip(zipf, FileNameInZip, (IntPtr)0, (IntPtr)0, 0, (IntPtr)0, 0, "", 8, -1);
        
        MinizipWrapper.zipWriteInFileInZip(zipf, buff, buff.Length);
        
        MinizipWrapper.zipCloseFileInZip(zipf);

        return true;
    }
    

/*
    #define APPEND_STATUS_CREATE        (0)
    #define APPEND_STATUS_CREATEAFTER   (1)
    #define APPEND_STATUS_ADDINZIP      (2)

    extern zipFile ZEXPORT zipOpen OF((const char *pathname, int append));
    extern int ZEXPORT zipOpenNewFileInZip OF((zipFile file,
                           const char* filename,
                           const zip_fileinfo* zipfi,
                           const void* extrafield_local,
                           uInt size_extrafield_local,
                           const void* extrafield_global,
                           uInt size_extrafield_global,
                           const char* comment,
                           int method,
                           int level));
    extern int ZEXPORT zipWriteInFileInZip OF((zipFile file,
                           const void* buf,
                           unsigned len));
    extern int ZEXPORT zipClose OF((zipFile file,
                    const char* global_comment));
*/
}

internal static class SvfDll
{
    const Int32 ERROR_MESSAGE_SIZE_SVF = 1024;

    #region EnumeratedTypes

    #endregion
    #region Structures
    #endregion
    #region CallBacks

    #endregion

    #region DLL Function Declarations



    /*  
int SVFAPI InitExtractSvfHelperEx(BOOL fPreventConcurrentExtracting);

int SVFAPI UninitExtractSvfHelper();
*/


    [DllImport("svfdll.dll", EntryPoint = "InitExtractSvfHelperEx", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int InitExtractSvfHelperEx(Boolean fPreventConcurrentExtracting);

    [DllImport("svfdll.dll", EntryPoint = "UninitExtractSvfHelper", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int UninitExtractSvfHelper();
    /*
     * 
     * int SVFAPI BuildPatchFromTwoFile(const char*DfsToBuild,const char*FirstFilename,const char*SecondFileName);


    /*
int SVFAPI BuildPatchFromTwoFileEx2(const char*DfsToBuild,const char*FirstFilename,const char*SecondFileName,char*errText,DWORD dwErrTextSize,
	signed long CompressRatio,signed long HashBits,signed long BlockSize);
    */


     
    [DllImport("svfdll.dll", EntryPoint = "BuildPatchFromTwoFile", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int BuildPatchFromTwoFile(string szSvfFileName, string FirstFilename, string SecondFileName);

    
    [DllImport("svfdll.dll", EntryPoint = "BuildPatchFromTwoFileEx", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int BuildPatchFromTwoFileEx(string szSvfFileName, string FirstFilename, string SecondFileName, StringBuilder errMsg, Int32 errMsgSize);
    
    [DllImport("svfdll.dll", EntryPoint = "BuildPatchFromTwoFileEx2", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int BuildPatchFromTwoFileEx2(string szSvfFileName, string FirstFilename, string SecondFileName, StringBuilder errMsg, Int32 errMsgSize,Int32 CompressRatio,Int32 HashBits,Int32 BlockSize);
    
    public static int BuildPatchFromTwoFileExOutString(string szSvfFileName, string FirstFilename, string SecondFileName, out string errMsg)
    {
        Int32 errSize = ERROR_MESSAGE_SIZE_SVF;
        StringBuilder sb = new StringBuilder(errSize + 1);
        Console.WriteLine("build patch {0} to {1} to {2}", FirstFilename, SecondFileName, szSvfFileName);
        int ret = BuildPatchFromTwoFileEx(szSvfFileName, FirstFilename, SecondFileName, sb, errSize);
        //Console.WriteLine("build ret= {0} ", ret);
        errMsg = sb.ToString();
        return ret;
    }

    public static int BuildPatchFromTwoFileExParamOutString(string szSvfFileName, string FirstFilename, string SecondFileName, out string errMsg,Int32 CompressRatio,Int32 HashBits,Int32 BlockSize)
    {
        Int32 errSize = ERROR_MESSAGE_SIZE_SVF;
        StringBuilder sb = new StringBuilder(errSize + 1);
        //Console.WriteLine("build patch {0} to {1} to {2}", FirstFilename, SecondFileName, szSvfFileName);
        int ret = -1;
        try
        {
            ret = BuildPatchFromTwoFileEx2(szSvfFileName, FirstFilename, SecondFileName, sb, errSize, CompressRatio, HashBits, BlockSize);
        }
        catch(Exception ex)
        {
            Console.WriteLine("---->** Exception in BuildPatchFromTwoFileEx2: " + FirstFilename +" to "+ SecondFileName+ " build "+ szSvfFileName);
            Console.WriteLine("---->** Exception in BuildPatchFromTwoFileEx2: " + ex.ToString());

        }
        //Console.WriteLine("build ret= {0} ", ret);
        errMsg = sb.ToString();
        return ret;
    }

    /*
     * 
    int SVFAPI RecompressPatch(const char* DfsOrg,const char*DfsToBuild, char*errText, dfuLong32 dwErrTextSize,
	   signed long CompressRatio, signed long HashBits, signed long BlockSize, signed long supp_flags);*/
    [DllImport("svfdll.dll", EntryPoint = "RecompressPatch", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int RecompressPatch(string szSvfFileNameOrg, string szSvfFileNameDest, StringBuilder errMsg, Int32 errMsgSize, Int32 CompressRatio, Int32 HashBits, Int32 BlockSize, Int32 supp_flag);

    public static int RecompressPatchString(string szSvfFileNameOrg, string szSvfFileNameDest, out string errMsg, Int32 CompressRatio, Int32 HashBits, Int32 BlockSize, Int32 supp_flag)
    {
        Int32 errSize = ERROR_MESSAGE_SIZE_SVF;
        StringBuilder sb = new StringBuilder(errSize + 1);

        int ret = RecompressPatch(szSvfFileNameOrg, szSvfFileNameDest, sb, errSize, CompressRatio, HashBits, BlockSize, supp_flag);
        
        
        errMsg = sb.ToString();
        return ret;
    }



    /*
     * 
    int SVFAPI AppendPatch(const char* DfsOrg,const char*DfsToAdd, char*errText, dfuLong32 dwErrTextSize);*/
    [DllImport("svfdll.dll", EntryPoint = "AppendPatch", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int AppendPatch(string szSvfFileNameOrg, string szSvfFileNameDest, StringBuilder errMsg, Int32 errMsgSize);

    public static int AppendPatchString(string szSvfFileNameOrg, string szSvfFileNameDest, out string errMsg)
    {
        Int32 errSize = ERROR_MESSAGE_SIZE_SVF;
        StringBuilder sb = new StringBuilder(errSize + 1);

        int ret = AppendPatch(szSvfFileNameOrg, szSvfFileNameDest, sb, errSize);

        errMsg = sb.ToString();
        return ret;
    }

    /*
     * BOOL ManualCopyFile(dfwcharpc lpExistingFileName,dfwcharpc lpNewFileName,BOOL bFailIfExists, BOOL fFlushWrite, H_ERROR_INFO * pei);
     * */


    [DllImport("svfdll.dll", EntryPoint = "ManualCopyFile", ExactSpelling = true, CharSet = CharSet.Unicode, SetLastError = true)]
    public static extern int ManualCopyFile(string szSvfFileNameOrg, string szSvfFileNameDest, Boolean bFailIfExists, Boolean fFlushWrite,IntPtr ptrNull);

    /*
     * BOOL SVFAPI MyDeleteFile(dfwcharpc lpFileName, H_ERROR_INFO * pei)
     * */

    [DllImport("svfdll.dll", EntryPoint = "MyDeleteFile", ExactSpelling = true, CharSet = CharSet.Unicode, SetLastError = true)]
    public static extern int MyDeleteFile(string szSvfFileName, IntPtr ptrNull);


    /*
     * BOOL CompareTwoFile(dfwcharpc lpExistingFileName,dfwcharpc lpNewFileName, H_ERROR_INFO * pei);
     * */


    [DllImport("svfdll.dll", EntryPoint = "CompareTwoFile", ExactSpelling = true, CharSet = CharSet.Unicode, SetLastError = true)]
    public static extern int CompareTwoFile(string szSvfFileNameOrg, string szSvfFileNameDest, IntPtr ptrNull);


    /*
     * BOOL SVFAPI DeleteTempFile(dfwcharpc lpFileName, H_ERROR_INFO* pei)     
     * */

    [DllImport("svfdll.dll", EntryPoint = "DeleteTempFile", ExactSpelling = true, CharSet = CharSet.Unicode, SetLastError = true)]
    public static extern int DeleteTempFile(string szSvfFileName, IntPtr ptrNull);


    /*
int SVFAPI GetSvfMonoPatchInfo(const char*patch,
                        KINDDFSFILE* pkdfsf,
                        char* BaseFileName,dfuLong32 BaseFileNameBufferSize,
                        dfuLong64* pSizeBase,
                        dfuLong32* pCrc32Base,BOOL *p_Crc32BaseFound,
                        unsigned char*bMd5Base,BOOL *p_Md5BaseFound,
                        unsigned char*bSha1Base,BOOL *p_Sha1BaseFound,
                        char* TargetFileName,dfuLong32 TargetFileNameBufferSize,
                        dfuLong64* pSizeTarget,
                        dfuLong32* pCrc32Target,BOOL *p_Crc32TargetFound,
                        unsigned char*bMd5Target,BOOL *p_Md5TargetFound,
                        unsigned char*bSha1Target,BOOL *p_Sha1TargetFound,
                        dfuLong64* pDeplInPlaceSize,dfuLong64 * pDeplOutPlaceSize,BOOL *p_InsertSizeFound,
                        ERROR_MOMENT *perr_moment,
                        int* perrinfo,char* errBufTxt,int errBufSize
                        );
    */

    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
    public struct MD5Info
    {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
        public byte[] md5bytes; //Supposed to be 16 bytes
    }

    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
    public struct SHA1Info
    {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)]
        public byte[] sha1bytes; //Supposed to be 20 bytes
    }


    public enum KindDfsFile
    {
        KINDDFSFILE_INVALID = 0,
        KINDDFSFILE_REFERENCE = 1,
        KINDDFSFILE_FULL = 2,
        KINDDFSFILE_PATCH = 3
    };
    
    [DllImport("svfdll.dll", EntryPoint = "GetSvfMonoPatchInfo", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int GetSvfMonoPatchInfo(string patch, ref KindDfsFile KindDfs,
        StringBuilder BaseFileNameTxt, Int32 BaseFileNameSize,
        ref UInt64 sizeBase,
        ref UInt32 crc32Base, ref Boolean baseFound,
        ref MD5Info md5Base, ref Boolean hasBaseMd5,
        ref SHA1Info sha1Base, ref Boolean hasBaseSha1,

        StringBuilder TargetFileNameTxt, Int32 TargetFileNameSize,
        ref UInt64 sizeTarget,
        ref UInt32 crc32Target, ref Boolean TargetFound,
        ref MD5Info md5Target, ref Boolean hasTargetMd5,
        ref SHA1Info sha1Target, ref Boolean hasTargetSha1,

        ref UInt64 deplInPlaceSize, ref UInt64 deplOutPlaceSize, ref Boolean fInsertSizeFound,
        ref int err_moment, ref int errinfo, StringBuilder errBufTxt, Int32 errBufSize);


    public static int GetSvfMonoPatchInfoString(
        string patch, ref KindDfsFile KindDfs,
        out string BaseFileName,
        ref UInt64 sizeBase,
        ref UInt32 crc32Base, ref Boolean baseFound,
        ref byte[] md5Base, ref Boolean hasBaseMd5,
        ref byte[] sha1Base, ref Boolean hasBaseSha1,

        out string TargetFileName,
        ref UInt64 sizeTarget,
        ref UInt32 crc32Target, ref Boolean TargetFound,
        ref byte[] md5Target, ref Boolean hasTargetMd5,
        ref byte[] sha1Target, ref Boolean hasTargetSha1,

        ref UInt64 deplInPlaceSize, ref UInt64 deplOutPlaceSize, ref Boolean fInsertSizeFound,
        ref int err_moment, ref int errinfo, out string errMsg)
    {

        Int32 errSize = ERROR_MESSAGE_SIZE_SVF;
        StringBuilder sb = new StringBuilder(errSize + 1);
        StringBuilder sbBaseName = new StringBuilder(errSize + 1);
        StringBuilder sbTargetName = new StringBuilder(errSize + 1);
        MD5Info md5BaseMarshall,md5TargetMarshall;
        SHA1Info sha1BaseMarshall,sha1TargetMarshall;
        md5BaseMarshall = new MD5Info();
        md5TargetMarshall = new MD5Info();
        sha1BaseMarshall = new SHA1Info();
        sha1TargetMarshall = new SHA1Info();
        

        int ret = GetSvfMonoPatchInfo(patch,ref KindDfs,
        sbBaseName, ERROR_MESSAGE_SIZE_SVF,
        ref sizeBase,
        ref crc32Base, ref baseFound,
        ref md5BaseMarshall, ref hasBaseMd5,
        ref sha1BaseMarshall, ref hasBaseSha1,
        
        sbTargetName, ERROR_MESSAGE_SIZE_SVF,
        ref sizeTarget,
        ref crc32Target, ref TargetFound,
        ref md5TargetMarshall, ref hasTargetMd5,
        ref sha1TargetMarshall, ref hasTargetSha1,

        ref deplInPlaceSize, ref deplOutPlaceSize, ref fInsertSizeFound,
        ref err_moment, ref errinfo, sb, errSize);

        md5Base = md5BaseMarshall.md5bytes;
        sha1Base = sha1BaseMarshall.sha1bytes;
        md5Target = md5TargetMarshall.md5bytes;
        sha1Target = sha1TargetMarshall.sha1bytes;
        //Console.WriteLine("build ret= {0} ", ret);
        errMsg = sb.ToString();
        BaseFileName = sbBaseName.ToString();
        TargetFileName = sbTargetName.ToString();
        return ret;
    }


    /*
int SVFAPI ApplyMonofilePatchEx(const char* base,int base_only_dir,
                       const char*patch,const char*dest,
                       ERROR_MOMENT *perr_moment,
                       int* perrinfo,char* errBufTxt,int errBufSize,dfuLong32 dfExtractingMethod);
     * */
    [DllImport("svfdll.dll", EntryPoint = "ApplyMonofilePatchEx", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
    public static extern int ApplyMonofilePatchEx(string szBase, Int32 base_only_dir, string patch, string dest,
        ref int err_moment,ref int errinfo,StringBuilder errBufTxt,Int32 errBufSize,UInt32 dfExtractingMethod);

    public static int ApplyMonofilePatchExString(string szBase, Int32 base_only_dir, string patch, string dest,
        ref int err_moment, ref int errinfo, out string errMsg, UInt32 dfExtractingMethod)
    {

        Int32 errSize = ERROR_MESSAGE_SIZE_SVF;
        StringBuilder sb = new StringBuilder(errSize + 1);

        int ret = ApplyMonofilePatchEx(szBase, base_only_dir, patch, dest,
         ref err_moment,ref errinfo,sb,errSize,dfExtractingMethod);
        //Console.WriteLine("build ret= {0} ", ret);
        errMsg = sb.ToString();
        return ret;
    }


    /*
     * 
BOOL SVFAPI MyCopyFile(dfwcharpc lpExistingFileName, dfwcharpc lpNewFileName, BOOL bFailIfExists, BOOL fFlushWrite, H_ERROR_INFO* pei);
BOOL SVFAPI MyDeleteFile(dfwcharpc lpFileName, H_ERROR_INFO* pei);

     * */

    public static string dispStringFromByteArray(byte[]hashData)
    {

        
        string hashText = String.Empty;
            foreach (byte b in hashData)
            {
                string hexValue = b.ToString("X").ToLower(); // Lowercase for compatibility on case-sensitive systems
                hashText += (hexValue.Length == 1 ? "0" : "") + hexValue;
            }
         return hashText;
    }
    #endregion
}
