/* DfsIntl.h */
/* function and structure to work on SVF file */


#if defined(__cplusplus) && (!defined(ALLINCPP))
extern "C" {
#endif

typedef struct
{
  dfuLong32 sizeStruct;
  dfuLong32 dfStatus;
  dfwcharpc filename;            /* filename or other info for open callback */
}
DFSFILEINFOPARAM;


typedef struct
{
  BOOL fStripIdenticalBody;
  BOOL fComputeMd5;
  BOOL fComputeSha1;
  BOOL fComputeSha256;
} DFSFEATUREPARAM;


DECLARE_DFHANDLE(DFSFILE);

//#define MAX_PATH_LENGTH (260)

/****************************************************************************/

dfuLong32 SVFAPI GetSvfVersion();
dfuLong32 SVFAPI GetSvfVersionDate();

dfuLong32 SVFAPI DfsOpen(DFSFILEINFOPARAM DfsFileParam, DFSFILE * DfsFile, H_ERROR_INFO * pei);

dfuLong32 SVFAPI DfsFileOpen(const DFSFILEINFOPARAM *pDfsFileParam, DFSFILE* DfsFile, H_ERROR_INFO* pei);

dfuLong32 SVFAPI DfsClose(DFSFILE, H_ERROR_INFO * pei);

dfuLong32 SVFAPI DfsFlushWriteDfsFile(DFSFILE, H_ERROR_INFO * pei);

/****************************************************************************/

void SVFAPI SetDfsExtendedMode(DFSFILE DfsFile, BOOL fStripIdenticalBody);
void SVFAPI GetDfsExtendedMode(DFSFILE DfsFile, BOOL* pfStripIdenticalBody);

void SVFAPI SetDfsFeatureParam(DFSFILE DfsFile, const DFSFEATUREPARAM*);
void SVFAPI GetDfsFeatureParam(DFSFILE DfsFile, DFSFEATUREPARAM*);

/****************************************************************************/

dfuLong32 SVFAPI DfsGetDirType(DFSFILE DfsFile, dfuLong32 dfNumDir, dfuLong32 * pdfDirType, H_ERROR_INFO * pei);

dfuLong32 SVFAPI DfsGetNbDir(DFSFILE DfsFile, dfuLong32 * pdfNbDir, H_ERROR_INFO * pei);

DFTAGBLOCKFLOAT SVFAPI GetDfsTagBlockFloat(DFSFILE DfsFile, H_ERROR_INFO * pei);

BOOL SVFAPI SetDfsTagBlockFloatDirty(DFSFILE DfsFile, H_ERROR_INFO * pei);

/************************************************************************/

#if defined(__cplusplus) && (!defined(ALLINCPP))
}
#endif
