/* DfsTagMg.h */
/* define function used to store tag */

#if defined(__cplusplus) && (!defined(ALLINCPP))
extern "C" {
#endif


DFTAGLIST SVFAPI AllocNewTagList();

BOOL SVFAPI IsTagListEmpty(DFTAGLIST TagList);

BOOL SVFAPI AddTag(DFTAGLIST TagList, dfuLong32 TagNumber, dfvoidpc TagBuf,
                   dfuLong32 TagSize);

BOOL SVFAPI DuplicateTagRange(DFTAGLIST TagListSrc,
                              DFTAGLIST TagListDst,
                              dfuLong32 TagNumberFirst,
                              dfuLong32 TagNumberLast);

BOOL SVFAPI RemoveTag(DFTAGLIST TagList, dfuLong32 TagNumber);

BOOL SVFAPI AddTaguLong(DFTAGLIST TagList, dfuLong32 TagNumber, dfuLong32 value);

BOOL SVFAPI BuildTagListPacking(DFTAGLIST TagList, dfvoidp * ptr, dfuLong32 * size,
                                BOOL compressed);

BOOL SVFAPI EndBuildTagList(DFTAGLIST TagList, dfvoidp * ptr, dfuLong32 * size,
                            BOOL compressed);

BOOL SVFAPI FreeTagPtr(dfvoidp ptr);

dfuLong32 SVFAPI GetCountOfTags(DFTAGLIST TagList);

dfuLong32 SVFAPI GetTagNumberAtPos(DFTAGLIST TagList, dfuLong32 pos);


/****************************************************************************/

#define READTAGSIZE_NOSIZELIMIT (0xffffffff)
DFTAGLIST SVFAPI ReadTagListSizeLimited(dfvoidp ptr, dfuLong32 * pTagListPackedSize,
                                        dfuLong32 dfLimit);

DFTAGLIST SVFAPI ReadTagList(dfvoidp ptr, dfuLong32 * pTagListPackedSize);

BOOL SVFAPI CloseTagList(DFTAGLIST TagList);

BOOL SVFAPI GetTag(DFTAGLIST TagList, dfuLong32 TagNumber, dfvoidp * pTagBuf,
                   dfuLong32 * pTagSize);

BOOL SVFAPI GetTaguLong(DFTAGLIST TagList, dfuLong32 TagNumber, dfuLong32 * value);


/*

  Tag relative to file
- DFSTAG_FILENAME : nom du fichier en unicode sans le zro terminal.
- DFSTAG_DATE : Date du fichier au format DFSINFODATE
- DFSTAG_BASEPATCH

  // only in final dir
- DFSTAG_FILEPOSPROPERTIES : localisation du fichier, en octets (sur 4 ou 8 octets).
- DFSTAG_CRCINFO : tableau de structures DFSCRCINFO (on connat le nombre de CRC avec la taille du TAG).



  Tag relative to the directory
- DFSTAG_NUMBEROFFILEINDIR
*/



#if defined(__cplusplus) && (!defined(ALLINCPP))
}
#endif
