/* DfsWrSet.h */
/* function to write a new version into SVF file */

#if defined(__cplusplus) && (!defined(ALLINCPP))
extern "C" {
#endif


typedef struct
{
  dfwcharpc   filename_tostore;
  dfwcharpc   filename_ondisk;
  dfwcharpc   filename_prevversionondisk;
  dfuLong32   dfPreviousVersionFilePosition;
  BOOL        fIgnore;

  BOOL        fForceRecopyPrevious;
  BOOL        fWritingRaw;
  dfuLong32   dfFileStatusForRaw;
  BOOL        fForceDate;
  DFTAGLIST   hAddTags; /* to be used later */
  DFSINFODATE dfsInfoDate;
  dfvoidp     pReserved; /* for future use */

  dfuLong64     dfForceRecopyOrRawCopySize;
  dfuLong32     dfForceRecopyOrRawCopyCrc32;
  BOOL          fForceRecopyOrRawCopyMd5Present;
  dfbyte        bMd5[16];
  BOOL          fForceRecopyOrRawCopySha1Present;
  dfbyte        bSha1[20];
  BOOL          fForceRecopyOrRawCopySha256Present;
  dfbyte        bSha256[32];

  HRAMDIF       hRamDifToFlushPatch;
}
FILETOADD;

/*
typedef struct
{
    dfuLong32 dfTypeInserting;
    dfuLong32 dfNbFile;
} -*/

#define TYPEDIR_FILECRCONLY             (1)
#define TYPEDIR_FILEINSERTING_STORE     (2)
#define TYPEDIR_FILEINSERTING_DEFLATE   (3)
#define TYPEDIR_PATCHFROMPREVIOUS       (4)


dfuLong32 SVFAPI InsertDirectoryinDfsFile(DFSFILE DfsFile, dfuLong32 dfTypeDir,
                                 dfuLong32 dfNbFile, FILETOADD * pFileToAdd,
                                 BOOL fWriteCrcAndSizeInFileToAddArray,
                                 dfwcharpc dfwVersionName,
                                 dfwcharpc dfwVersionComment,
                                 const COMPRESSIONPARAM* pCprParam,
                                 tProgressCallBack pProgressCallBack,
                                 dfvoidp dfUserPtr,
                                 H_ERROR_INFO* pei);

#define DF_PROGRESS_EVENT_NEWDIR    (1)
#define DF_PROGRESS_EVENT_NEWFILE   (2)
#define DF_PROGRESS_EVENT_PROGRESS  (3)

#if defined(__cplusplus) && (!defined(ALLINCPP))
}
#endif
