/* DirSet.h */
/* basic structure and tools to extract several version at a time */

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
    ExtActionIgnore,
    ExtActionExtractContent,
    ExtActionMergeRamDif,
    ExtActionExtractContentInPlace,
    ExtActionExtractContentInPlaceNoChecksum,
    ExtActionExtractContentByMerging
} EXTACTION;

typedef struct
{
  dfwcharpc FileNameOnDisk;
  dfwcharpc FileNameOnArchive;
  ///dfuLong64 dfFileSizeUncompressed;
  BOOL      fTempFile;
  dfuLong32 dfPreviousVersion;
  BOOL      fIdenticalPreviousVersion;
  //BOOL      fIgnore;// replace with enum
  EXTACTION ExtAction;
  BOOL      fForceDate;
  DFTAGLIST   hAddTags;
  DFSINFODATE dfsInfoDate;
  dfvoidp   pReserved;
  HRAMDIF   hRamDifOfPatch ;
}
FILEITEM;
typedef FILEITEM *PFILEITEM;


typedef struct
{
  dfuLong32 dfNbFileItem;
  dfuLong32 dfFileItemStepAlloc;
  dfuLong32 dfFileItemAllocated;
  BOOL fTempFile;
  FILEITEM *pFileItem;
}
FILESET;

void SVFAPI InitFileSet(FILESET * pfs);
void SVFAPI FreeFileSet(FILESET * pfs, BOOL fDeleteFile);

BOOL SVFAPI AddItemToFileSet(FILESET * pfs, const FILEITEM * lpfi,
                      dfuLong32 dfNbFileItem);





BOOL SVFAPI ExtractPatch(DFSFILE DfsFile, FILESET * pfsOrg, FILESET * pfsDest,
                  dfuLong32 dfNumDirBase,PCDIRINFO pDirInfo,
                  BOOL fNewFileSetTemp, BOOL fOldFileCanBeCaptured,BOOL fFlushWrite,
                  dfwcharpc szBasePath,
                  tProgressCallBack pProgressCallBack,dfvoidp dfUserPtr,
                  tExtractingFileWorkingEvent pExtractingFileWorkingEvent,dfvoidp dfUserPtrWorkingEvent,
                  H_ERROR_INFO* pei);

/*

Create a FILESET Array for a version and a directory

  pfComplete : Will receive BOOL to known if all is good
  fVerboseNotFound : if must do printf for error
  fFillNameOnDisk : Always fill the FileNameOnDisk item and search the file
  fTryFindFileOnDiskIfNotInsertingInDfs : if TRUE, fill the FileNameOnDisk
                    item and search the file and NOT Inserting (Patch or CRC)
  fTryFindFileOnDiskIfInsertingInDfs : if TRUE, fill the FileNameOnDisk
                    item and search the file and Inserting (DEFLATE or uncompressed)

  pdfTypeDir : Will receive the type of the dir


*/

dfuLong32 SVFAPI CreateFileSetForVersionInDirectory(DFSFILE DfsFile, FILESET * pfs,
                                           dfuLong32 dfNumDir,
                                           dfwcharpc szDirBase,const FILESET* pFileSetBase,
                                           PCDIRINFO pDirInfoAlreadyProvided,
                                           BOOL * pfComplete,
                                           BOOL fVerboseNotFound,
                                           BOOL fFillNameOnDisk,
                                           BOOL
                                           fTryFindFileOnDiskIfNotInsertingInDfs,
                                           BOOL
                                           fTryFindFileOnDiskIfInsertingInDfs,
                                           dfuLong32 * pdfTypeDir,
                                           BOOL fFillForceFileDateFromDirectoryInDfs,
                                           BOOL fFlatFileSet,H_ERROR_INFO* pei);

 
long DFSCALLBACK fncCompareFileItem(const void* lpElem1, const void* lpElem2);
BOOL DFSCALLBACK fncDestructorFileItem(const void* lpElem);





#ifdef __cplusplus
}
#endif
