/* DoExtracting.h */
/* Extract several version in one time */

#ifdef __cplusplus
extern "C" {
#endif

	
#ifndef T_SET_EXTRACT_POS_CALLBACK_DEFINED
#define T_SET_EXTRACT_POS_CALLBACK_DEFINED
typedef BOOL(DFSCALLBACK * tSetExtractPosCallBack) (dfuLong32 dwPos,
                                                    dfvoidp dfpAdditionnalInfo,
                                                    dfvoidp dfUserPtr);
#endif

typedef dfuLong32(DFSCALLBACK * tConfirmBeforeCreatingFile)(dfwcharpc dfFileName,
                                                          dfvoidp dfpAdditionnalInfo,
                                                          dfvoidp dfUserPtr);


#define DFCBXTR_AFTERVERSIONEXTRACTED         (0x00000100)
#define DFCBXTR_BEFOREDELETEPREVIOUS          (0x00000101)


#define CONFIRM_BEFORE_CREATING_FILE_OK (0x0)
#define CONFIRM_BEFORE_CREATING_FILE_SKIP (0x1)
#define CONFIRM_BEFORE_CREATING_FILE_STOP (0x2)

typedef enum
{
    ExtractNone = 0,
    ExtractClassic,
    ExtractInPlace,
    ExtractInPlaceNoChecksum,
    ExtractByMerging,
} EXTRACTINGMAPITEM;

typedef struct
{
    dfuLong32 dfMapFileNumber;
    const EXTRACTINGMAPITEM*   pExtractingMap;
//    const BOOL*   pExtractingMap;
} EXTRACTINGMAPINFO;


typedef struct
{
  dfuLong32 dfSizeStruct;
  DFSFILE DfsFile;

  dfvoidp dfDataEventPtr;
  dfvoidp dfReserved;
} DFCBXTR_CALLBACKINFO;

BOOL SVFAPI DoMultiExtracting(DFSFILE DfsFile,dfwcharpc wchBaseDirExtract,
                              FILESET** ppfsDest,BOOL fTempDestExtr,dfuLong32 dfDirExtr,
                              const PDIRINFO* pDirInfo,
                              BOOL fBaseDirectorySelected,dfuLong32 dfBaseDirNum,dfwcharpc wchBaseDirectory,const FILESET* pFileSetBase,
                              dfuLong32 dwMapFileNumber,const EXTRACTINGMAPITEM* lpExtractingMap,
                              EXTRACTINGMAPINFO* pExtractingMapInfo,
                              tSetExtractPosCallBack pSetExtractPosCallBack,dfvoidp dfUserPtr,
                              tConfirmBeforeCreatingFile pConfirmBeforeCreatingFile, dfvoidp dfUserPtrBeforeCreatingFile,
                              tExtractingFileWorkingEvent pExtractingFileWorkingEvent, dfvoidp dfUserExtractingFileWorkingEvent,
                              dfuLong32 dwMinProgress,dfuLong32 dwMaxProgress,BOOL fFlatExtracting, BOOL fFlushWrite, H_ERROR_INFO * pei);


BOOL SVFAPI DoGenerateSubDfs(DFSFILE DfsFileRead,/*dfuLong32 dfNbDir,*/PDIRINFO* pDirInfo,
                             DFSFILE *pDfsFileWrite,dfwcharpc dfWritingDfsFileName, /*BOOL fZipFile,*/
                             const DFSFEATUREPARAM* pFeatureParam,
                             BOOL fBaseDirectorySelected,dfuLong32 dfBaseDirNum,dfwcharpc wchBaseDirectory,const FILESET* pFileSetBase,
                             dfuLong32 dwNbMapVersionMap,const BOOL* lpVersionMap,
                             BOOL fFirstVersionAsReference,BOOL fReuseOldPatch /* future*/,
                             const COMPRESSIONPARAM* pCprParam,
                             tSetExtractPosCallBack pSetExtractPosCallBack,dfvoidp dfUserPtr,
                             dfuLong32 dwMinProgress,dfuLong32 dwMaxProgress,
                             H_ERROR_INFO * pei);


BOOL SVFAPI BuildZipFileFromFileSet(FILESET* pfsDest,dfwcharpc dfwcZipFileName,int opt_compress_level,
                             dfwcharp dfwVersionName,
                             tSetExtractPosCallBack pSetExtractPosCallBack,dfvoidp dfUserPtr,
                             dfuLong32 dwMinProgress,dfuLong32 dwMaxProgress, H_ERROR_INFO * pei);


/************************************************************************/

#ifdef __cplusplus
}
#endif
