
typedef long (DFSCALLBACK *tCompareData) (LPCVOID lpElem1, LPCVOID lpElem2);
typedef BOOL(DFSCALLBACK *tDestructorData) (LPCVOID lpElem);


#ifdef __cplusplus

class STATIC_ARRAY
{
public:
  STATIC_ARRAY(dfuLong32 dwSizeElem = sizeof(LPVOID), dfuLong32 dwStepAlloc = 256, dfuLong32 dwFirstAlloc = 0);
  ~STATIC_ARRAY();
  dfuLong32 GetNbElemSA() const;
  BOOL InitStaticArray(dfuLong32 dwSizeElem = sizeof(LPVOID),
                       dfuLong32 dwStepAlloc = 256,
                       dfuLong32 dwFirstAlloc = 0);
  BOOL ReservAllocationSA(dfuLong32 dwNbReserv);
  BOOL DeleteElemSA(dfuLong32 dwPos, dfuLong32 dwNbElem = 1);
  BOOL InsertElemSA(dfuLong32 dwPos, LPCVOID lpData);
  BOOL SetElemSA(dfuLong32 dwPos, LPCVOID lpData);
  BOOL GetElemSA(dfuLong32 dwPos, LPVOID lpData) const;
  LPCVOID GetElemPtrSA(dfuLong32 dwPos) const;
  BOOL AddEndElemSA(LPCVOID lpData);
  BOOL SetFuncCompareDataSA(tCompareData fCompareDataSet, BOOL fForce=FALSE);
  BOOL SetFuncDestructorSA(tDestructorData fDestructorDataSet);
  BOOL InsertSortedSA(LPCVOID lpData);
  BOOL FindSameElemPosSA(LPCVOID lpDataElem, dfuLong32* lpdwPos) const;
private:
  BOOL SetNbAlloc(dfuLong32 dwNbAllocNew);
  BOOL CheckNbAlloc(dfuLong32 dwNbAllocNeeded);

  dfuLong32 dwNbUsed;
  dfuLong32 dwNbAlloc;
  dfuLong32 dwSizeElem;
  dfuLong32 dwStepAlloc;
  LPBYTE lpData;
  tCompareData fCompareData;
  tDestructorData fDestructorData;
};

#endif
