/* SvfDll.h
    Main header of SmartVersion SDK
    Please include this header in your file */


/* difbasic.h define basic type and structure for SmartVersion engine */
#include "difbasic.h"

/* DfsTlTyp.h define complex structure for SmartVersion engine and SVF file */
#include "DfsTlTyp.h"

/* DifsTool.h Basic tools (disk, memory, date, charset, error management) */
#include "difstool.h"

/* ArrayTl.h basic function to manage an array of fixed item in memory */
#include "ArrayTl.h"

/* DfsOrigMemoryMap.h define macro to get access on the original version of a file */
#include "DfsOrigMemoryMap.h"

/* DfsIOhlp.h Basic low level disk function, including memory mapped */
#include "DfsIoHlp.h"

/* DfsStruc.h Structure of meta header on SVF file */
#include "DfsStruc.h"

/* DfsTagDf.h define constant used to store tag */
#include "DfsTagDf.h"

/* DfsTagMg.h define function used to store tag */
#include "DfsTagMg.h"

/* DfsTagBlockFloatEnd.h
   Managenet of tag at the end of DFS File (tag which are modified) */
#include "DfsTagBlockFloatEnd.h"

/* difstrm.h contain a function to create a "dummy" stream with identical patch */
#include "difstrm.h"

/* apldifst.h function and structure to execute a stream patch from two file */
#include "apldifst.h"

/* makdifst.h function to build a stream patch from two file */
#include "makdifst.h"

/* DfsIntf.h basic function and structure to work on SVF file */
#include "DfsIntf.h"

/* dfsSet.h define callback used during work on SVF file */
#include "DfsSet.h"

/* RamDifWk.h */
/* function to deal merging patch in ramdif */
#include "RamDifWk.h"


#include "RamDifTl.h"
#include "RamDifWS.h"

/* DfsWrSet.h */
/* function to write a new version into SVF file */
#include "DfsWrSet.h"



/* DfsRdSet.h */
/* function to extract a version into SVF file, based on previous version */
#include "DfsRdSet.h"

/* DirSet.h basic structure and tools to extract several version at a time */
#include "DirSet.h"

/* DoExtracting.h Extract several version in one time */
#include "DoExtracting.h"

/* RemixDfs.h Modify version in a Dfs */
#include "ReMixDfs.h"

/* ReMixHelper.h function to be used with Remix */
#include "ReMixHelper.h"

/* AppendDfs.h append one SVF file to another */
#include "AppendDfs.h"
